Option Compare Binary
Option Explicit On
Option Strict On

Imports System

''' <summary>Represents a Win32 integer resource identifier.</summary>
Public NotInheritable Class IntegerResourceId
    Inherits ResourceId

    Private m_Value As IntPtr

    ''' <summary>Initializes a new instance of the class.</summary>
    ''' <param name="Value">The value of the resource identifier.</param>
    Public Sub New(ByVal Value As IntPtr)
        Me.Value = Value
    End Sub

    ''' <summary>Initializes a new instance of the class.</summary>
    ''' <param name="Value">The value of the resource identifier.</param>
    Public Sub New(ByVal Value As Integer)
        Me.Value = New IntPtr(Value)
    End Sub

    ''' <summary>
    '''   Gets or sets the value of the resource identifier.
    ''' </summary>
    ''' <value>The value of the resource identifier.</value>
    ''' <returns>
    '''   A <c>System.IntPtr</c> object representing the value of the
    '''   resource identifier.
    ''' </returns>
    Public Property Value() As IntPtr
        Get
            Return m_Value
        End Get
        Private Set(ByVal Value As IntPtr)
            m_Value = Value
        End Set
    End Property

    ''' <summary>
    '''   Returns an integer representing the resource identifier.
    ''' </summary>
    ''' <returns>An integer representing the resource identifier.</returns>
    Public Function ToInt32() As Integer
        Return Me.Value.ToInt32()
    End Function

    ''' <summary>Returns a string representing the object.</summary>
    ''' <returns>A string representing the object.</returns>
    Public Overrides Function ToString() As String
        Return "#" & Me.Value.ToString()
    End Function
End Class