Option Compare Binary
Option Explicit On
Option Strict On

Imports Microsoft.VisualBasic
Imports System
Imports System.ComponentModel

''' <summary>Unmanaged Win32 functions.</summary>
Friend NotInheritable Class NativeMethods
    Private Sub New()
        '
    End Sub

#Region "LoadImage"
    Friend Declare Auto Function LoadImage Lib "user32.dll" ( _
        ByVal hinst As IntPtr, _
        ByVal lpszName As IntPtr, _
        ByVal uType As IMAGE_Constants, _
        ByVal cxDesired As Int32, _
        ByVal cyDesired As Int32, _
        ByVal fuLoad As LR_Flags _
    ) As IntPtr

    Friend Declare Auto Function LoadImage Lib "user32.dll" ( _
        ByVal hinst As IntPtr, _
        ByVal lpszName As String, _
        ByVal uType As IMAGE_Constants, _
        ByVal cxDesired As Int32, _
        ByVal cyDesired As Int32, _
        ByVal fuLoad As LR_Flags _
    ) As IntPtr

    Friend Shared Function LoadImage( _
        ByVal hinst As IntPtr, _
        ByVal Id As ResourceId, _
        ByVal uType As IMAGE_Constants, _
        ByVal cxDesired As Int32, _
        ByVal cyDesired As Int32, _
        ByVal fuLoad As LR_Flags _
    ) As IntPtr
        If TypeOf Id Is IntegerResourceId Then
            Return LoadImage(hinst, DirectCast(Id, IntegerResourceId).Value, uType, cxDesired, cyDesired, fuLoad)
        Else
            Return LoadImage(hinst, (DirectCast(Id, StringResourceId).Value), uType, cxDesired, cyDesired, fuLoad)
        End If
    End Function
#End Region

    Friend Enum IMAGE_Constants
        IMAGE_BITMAP = 0
        IMAGE_ICON = 1
        IMAGE_CURSOR = 2
    End Enum

    <Flags()> _
    Friend Enum LR_Flags
        LR_DEFAULTCOLOR = &H0
        LR_CREATEDIBSECTION = &H2000
        LR_DEFAULTSIZE = &H40
        LR_LOADFROMFILE = &H10
        LR_LOADMAP3DCOLORS = &H1000
        LR_LOADTRANSPARENT = &H20
        LR_MONOCHROME = &H1
        LR_SHARED = &H8000
        LR_VGACOLOR = &H80
    End Enum

    Friend Enum OBM_Constants
        OBM_BTNCORNERS = 32758
        OBM_BTSIZE = 32761
        OBM_CHECK = 32760
        OBM_CHECKBOXES = 32759
        OBM_CLOSE = 32754
        OBM_COMBO = 32738
        OBM_DNARROW = 32752
        OBM_DNARROWD = 32742
        OBM_DNARROWI = 32736
        OBM_LFARROW = 32750
        OBM_LFARROWD = 32740
        OBM_LFARROWI = 32734
        OBM_MNARROW = 32739
        OBM_OLD_CLOSE = 32767
        OBM_OLD_DNARROW = 32764
        OBM_OLD_LFARROW = 32762
        OBM_OLD_REDUCE = 32757
        OBM_OLD_RESTORE = 32755
        OBM_OLD_RGARROW = 32763
        OBM_OLD_UPARROW = 32765
        OBM_OLD_ZOOM = 32756
        OBM_REDUCE = 32749
        OBM_REDUCED = 32746
        OBM_RESTORE = 32747
        OBM_RESTORED = 32744
        OBM_RGARROW = 32751
        OBM_RGARROWD = 32741
        OBM_RGARROWI = 32735
        OBM_SIZE = 32766
        OBM_UPARROW = 32753
        OBM_UPARROWD = 32743
        OBM_UPARROWI = 32737
        OBM_ZOOM = 32748
        OBM_ZOOMD = 32745
    End Enum

    Friend Declare Auto Function LoadString Lib "user32.dll" ( _
        ByVal hInstance As IntPtr, _
        ByVal uID As Int32, _
        ByVal lpBuffer As String, _
        ByVal nBufferMax As Int32 _
    ) As Int32

#Region "FormatMessage"
    Friend Declare Auto Function FormatMessage Lib "kernel32.dll" ( _
        ByVal dwFlags As FORMAT_MESSAGE_Flags, _
        ByVal lpSource As IntPtr, _
        ByVal dwMessageId As Int32, _
        ByVal dwLanguageId As Int32, _
        ByRef lpBuffer As IntPtr, _
        ByVal nSize As Int32, _
        ByVal Arguments() As String _
    ) As Int32

    Friend Declare Auto Function FormatMessage Lib "kernel32.dll" ( _
        ByVal dwFlags As FORMAT_MESSAGE_Flags, _
        ByVal lpSource As String, _
        ByVal dwMessageId As Int32, _
        ByVal dwLanguageId As Int32, _
        ByRef lpBuffer As IntPtr, _
        ByVal nSize As Int32, _
        ByVal Arguments() As String _
    ) As Int32
#End Region

    ' Return value of 'FormatMessage' if resource type could not be found.
    'Friend Const ERROR_RESOURCE_LANG_NOT_FOUND As Int32 = 1815

    <Flags()> _
    Friend Enum FORMAT_MESSAGE_Flags
        FORMAT_MESSAGE_ALLOCATE_BUFFER = &H100
        FORMAT_MESSAGE_IGNORE_INSERTS = &H200
        FORMAT_MESSAGE_FROM_STRING = &H400
        FORMAT_MESSAGE_FROM_HMODULE = &H800
        FORMAT_MESSAGE_FROM_SYSTEM = &H1000
        FORMAT_MESSAGE_ARGUMENT_ARRAY = &H2000
        FORMAT_MESSAGE_MAX_WIDTH_MASK = &HFF&
    End Enum

    Private Const DIFFERENCE As Int32 = 11

    Friend Enum RT_Constants
        RT_CURSOR = 1
        RT_BITMAP = 2
        RT_ICON = 3
        RT_MENU = 4
        RT_DIALOG = 5
        RT_STRING = 6
        RT_FONTDIR = 7
        RT_FONT = 8
        RT_ACCELERATOR = 9
        RT_RCDATA = 10
        RT_MESSAGETABLE = 11
        RT_GROUP_CURSOR = RT_CURSOR + DIFFERENCE
        RT_GROUP_ICON = RT_ICON + DIFFERENCE
        RT_VERSION = 16
        RT_DLGINCLUDE = 17
        RT_PLUGPLAY = 19
        RT_VXD = 20
        RT_ANICURSOR = 21
        RT_ANIICON = 22
        RT_HTML = 23
        RT_MANIFEST = 24
    End Enum

    Friend Declare Auto Function EnumResourceTypes Lib "kernel32.dll" ( _
        ByVal hModule As IntPtr, _
        ByVal lpEnumFunc As EnumResTypeProc, _
        ByVal lParam As IntPtr _
    ) As Boolean

    Friend Delegate Function EnumResTypeProc( _
        ByVal hModule As IntPtr, _
        ByVal lpszType As IntPtr, _
        ByVal lParam As IntPtr _
    ) As Boolean

#Region "EnumResourceNames"
    Friend Declare Auto Function EnumResourceNames Lib "kernel32.dll" ( _
        ByVal hModule As IntPtr, _
        ByVal lpType As IntPtr, _
        ByVal lpEnumFunc As EnumResNameProc, _
        ByVal lParam As IntPtr _
    ) As Boolean

    Friend Declare Auto Function EnumResourceNames Lib "kernel32.dll" ( _
        ByVal hModule As IntPtr, _
        ByVal lpType As String, _
        ByVal lpEnumFunc As EnumResNameProc, _
        ByVal lParam As IntPtr _
    ) As Boolean

    Friend Shared Function EnumResourceNames( _
        ByVal hModule As IntPtr, _
        ByVal Type As ResourceType, _
        ByVal lpEnumFunc As EnumResNameProc, _
        ByVal lParam As IntPtr _
    ) As Boolean
        If TypeOf Type Is IntegerResourceType Then
            Return EnumResourceNames(hModule, DirectCast(Type, IntegerResourceType).Value, lpEnumFunc, lParam)
        Else
            Return EnumResourceNames(hModule, (DirectCast(Type, StringResourceType).Value), lpEnumFunc, lParam)
        End If
    End Function
#End Region

    ' Return values of 'GetLastError' after calling 'EnumResourceNames' if
    ' no resources of the specified type could be found.
    Friend Const NO_ERROR As Int32 = 0                          ' Windows 95/98/Me.
    Friend Const ERROR_RESOURCE_TYPE_NOT_FOUND As Int32 = 1813  ' Windows NT/2000/XP.

    Friend Delegate Function EnumResNameProc( _
        ByVal hModule As IntPtr, _
        ByVal lpszType As IntPtr, _
        ByVal lpszName As IntPtr, _
        ByVal lParam As IntPtr _
    ) As Boolean

#Region "EnumResourceLanguages"
    Friend Declare Auto Function EnumResourceLanguages Lib "kernel32.dll" ( _
        ByVal hModule As IntPtr, _
        ByVal lpType As IntPtr, _
        ByVal lpName As IntPtr, _
        ByVal lpEnumFunc As EnumResLangProc, _
        ByVal lParam As IntPtr _
    ) As Boolean

    Friend Declare Auto Function EnumResourceLanguages Lib "kernel32.dll" ( _
        ByVal hModule As IntPtr, _
        ByVal lpType As String, _
        ByVal lpName As String, _
        ByVal lpEnumFunc As EnumResLangProc, _
        ByVal lParam As IntPtr _
    ) As Boolean

    Friend Declare Auto Function EnumResourceLanguages Lib "kernel32.dll" ( _
        ByVal hModule As IntPtr, _
        ByVal lpType As String, _
        ByVal lpName As IntPtr, _
        ByVal lpEnumFunc As EnumResLangProc, _
        ByVal lParam As IntPtr _
    ) As Boolean

    Friend Declare Auto Function EnumResourceLanguages Lib "kernel32.dll" ( _
        ByVal hModule As IntPtr, _
        ByVal lpType As IntPtr, _
        ByVal lpName As String, _
        ByVal lpEnumFunc As EnumResLangProc, _
        ByVal lParam As IntPtr _
    ) As Boolean

    Friend Shared Function EnumResourceLanguages( _
        ByVal hModule As IntPtr, _
        ByVal Type As ResourceType, _
        ByVal Name As ResourceId, _
        ByVal lpEnumFunc As EnumResLangProc, _
        ByVal lParam As IntPtr _
    ) As Boolean
        If TypeOf Type Is IntegerResourceType Then
            If TypeOf Name Is IntegerResourceId Then
                Return EnumResourceLanguages(hModule, DirectCast(Type, IntegerResourceType).Value, DirectCast(Name, IntegerResourceId).Value, lpEnumFunc, lParam)
            Else
                Return EnumResourceLanguages(hModule, DirectCast(Type, IntegerResourceType).Value, (DirectCast(Name, StringResourceId).Value), lpEnumFunc, lParam)
            End If
        Else
            If TypeOf Name Is IntegerResourceId Then
                Return EnumResourceLanguages(hModule, (DirectCast(Type, StringResourceType).Value), DirectCast(Name, IntegerResourceId).Value, lpEnumFunc, lParam)
            Else
                Return EnumResourceLanguages(hModule, (DirectCast(Type, StringResourceType).Value), (DirectCast(Name, StringResourceId).Value), lpEnumFunc, lParam)
            End If
        End If
    End Function
#End Region

    Friend Delegate Function EnumResLangProc( _
        ByVal hModule As IntPtr, _
        ByVal lpszType As IntPtr, _
        ByVal lpszName As IntPtr, _
        ByVal wIDLanguage As Int16, _
        ByVal lParam As IntPtr _
    ) As Boolean

#Region "FindResource"
    Friend Declare Auto Function FindResource Lib "kernel32.dll" ( _
        ByVal hModule As IntPtr, _
        ByVal lpName As IntPtr, _
        ByVal lpType As IntPtr _
    ) As IntPtr

    Friend Declare Auto Function FindResource Lib "kernel32.dll" ( _
        ByVal hModule As IntPtr, _
        ByVal lpName As String, _
        ByVal lpType As String _
    ) As IntPtr

    Friend Declare Auto Function FindResource Lib "kernel32.dll" ( _
        ByVal hModule As IntPtr, _
        ByVal lpName As String, _
        ByVal lpType As IntPtr _
    ) As IntPtr

    Friend Declare Auto Function FindResource Lib "kernel32.dll" ( _
        ByVal hModule As IntPtr, _
        ByVal lpName As IntPtr, _
        ByVal lpType As String _
    ) As IntPtr

    Friend Shared Function FindResource( _
        ByVal hModule As IntPtr, _
        ByVal Name As ResourceId, _
        ByVal Type As ResourceType _
    ) As IntPtr
        If TypeOf Name Is IntegerResourceId Then
            If TypeOf Type Is IntegerResourceType Then
                Return FindResource(hModule, DirectCast(Name, IntegerResourceId).Value, DirectCast(Type, IntegerResourceType).Value)
            Else
                Return FindResource(hModule, DirectCast(Name, IntegerResourceId).Value, (DirectCast(Type, StringResourceType).Value))
            End If
        Else
            If TypeOf Type Is IntegerResourceType Then
                Return FindResource(hModule, (DirectCast(Name, StringResourceId).Value), DirectCast(Type, IntegerResourceType).Value)
            Else
                Return FindResource(hModule, (DirectCast(Name, StringResourceId).Value), (DirectCast(Type, StringResourceType).Value))
            End If
        End If
    End Function
#End Region

#Region "FindResourceEx"
    Friend Declare Auto Function FindResourceEx Lib "kernel32.dll" ( _
        ByVal hModule As IntPtr, _
        ByVal lpType As IntPtr, _
        ByVal lpName As IntPtr, _
        ByVal wLanguage As Int16 _
    ) As IntPtr

    Friend Declare Auto Function FindResourceEx Lib "kernel32.dll" ( _
        ByVal hModule As IntPtr, _
        ByVal lpType As String, _
        ByVal lpName As String, _
        ByVal wLanguage As Int16 _
    ) As IntPtr

    Friend Declare Auto Function FindResourceEx Lib "kernel32.dll" ( _
        ByVal hModule As IntPtr, _
        ByVal lpType As String, _
        ByVal lpName As IntPtr, _
        ByVal wLanguage As Int16 _
    ) As IntPtr

    Friend Declare Auto Function FindResourceEx Lib "kernel32.dll" ( _
        ByVal hModule As IntPtr, _
        ByVal lpType As IntPtr, _
        ByVal lpName As String, _
        ByVal wLanguage As Int16 _
    ) As IntPtr

    Friend Shared Function FindResourceEx( _
        ByVal hModule As IntPtr, _
        ByVal Type As ResourceType, _
        ByVal Name As ResourceId, _
        ByVal wLanguage As Int16 _
    ) As IntPtr
        If TypeOf Name Is IntegerResourceId Then
            If TypeOf Type Is IntegerResourceType Then
                Return FindResourceEx(hModule, DirectCast(Type, IntegerResourceType).Value, DirectCast(Name, IntegerResourceId).Value, wLanguage)
            Else
                Return FindResourceEx(hModule, (DirectCast(Type, StringResourceType).Value), DirectCast(Name, IntegerResourceId).Value, wLanguage)
            End If
        Else
            If TypeOf Type Is IntegerResourceType Then
                Return FindResourceEx(hModule, DirectCast(Type, IntegerResourceType).Value, (DirectCast(Name, StringResourceId).Value), wLanguage)
            Else
                Return FindResourceEx(hModule, (DirectCast(Type, StringResourceType).Value), (DirectCast(Name, StringResourceId).Value), wLanguage)
            End If
        End If
    End Function
#End Region

    Friend Declare Unicode Function LoadResource Lib "kernel32.dll" ( _
        ByVal hModule As IntPtr, _
        ByVal hResInfo As IntPtr _
    ) As IntPtr

    Friend Declare Unicode Function LockResource Lib "kernel32.dll" ( _
        ByVal hResData As IntPtr _
    ) As IntPtr

    Friend Declare Unicode Function SizeofResource Lib "kernel32.dll" ( _
        ByVal hModule As IntPtr, _
        ByVal hResInfo As IntPtr _
    ) As Int32

    Friend Declare Unicode Function FreeResource Lib "kernel32.dll" ( _
        ByVal hglbResource As IntPtr _
    ) As Boolean

    Friend Declare Auto Function BeginUpdateResource Lib "kernel32.dll" ( _
        ByVal pFileName As String, _
        ByVal bDeleteExistingResources As Boolean _
    ) As IntPtr

    Friend Declare Auto Function EndUpdateResource Lib "kernel32.dll" ( _
        ByVal hUpdate As IntPtr, _
        ByVal fDiscard As Boolean _
    ) As Boolean

#Region "UpdateResource"
    Friend Declare Auto Function UpdateResource Lib "kernel32.dll" ( _
        ByVal hUpdate As IntPtr, _
        ByVal lpType As String, _
        ByVal lpName As String, _
        ByVal wLanguage As Int16, _
        ByVal lpData() As Byte, _
        ByVal cbData As Int32 _
    ) As Boolean

    Friend Declare Auto Function UpdateResource Lib "kernel32.dll" ( _
        ByVal hUpdate As IntPtr, _
        ByVal lpType As IntPtr, _
        ByVal lpName As IntPtr, _
        ByVal wLanguage As Int16, _
        ByVal lpData() As Byte, _
        ByVal cbData As Int32 _
    ) As Boolean

    Friend Declare Auto Function UpdateResource Lib "kernel32.dll" ( _
        ByVal hUpdate As IntPtr, _
        ByVal lpType As String, _
        ByVal lpName As IntPtr, _
        ByVal wLanguage As Int16, _
        ByVal lpData() As Byte, _
        ByVal cbData As Int32 _
    ) As Boolean

    Friend Declare Auto Function UpdateResource Lib "kernel32.dll" ( _
        ByVal hUpdate As IntPtr, _
        ByVal lpType As IntPtr, _
        ByVal lpName As String, _
        ByVal wLanguage As Int16, _
        ByVal lpData() As Byte, _
        ByVal cbData As Int32 _
    ) As Boolean

    Friend Shared Function UpdateResource( _
        ByVal hUpdate As IntPtr, _
        ByVal Type As ResourceType, _
        ByVal Name As ResourceId, _
        ByVal wLanguage As Int16, _
        ByVal lpData() As Byte, _
        ByVal cbData As Int32 _
    ) As Boolean
        If TypeOf Name Is IntegerResourceId Then
            If TypeOf Type Is IntegerResourceType Then
                Return UpdateResource(hUpdate, DirectCast(Type, IntegerResourceType).Value, DirectCast(Name, IntegerResourceId).Value, wLanguage, lpData, cbData)
            Else
                Return UpdateResource(hUpdate, (DirectCast(Type, StringResourceType).Value), DirectCast(Name, IntegerResourceId).Value, wLanguage, lpData, cbData)
            End If
        Else
            If TypeOf Type Is IntegerResourceType Then
                Return UpdateResource(hUpdate, DirectCast(Type, IntegerResourceType).Value, (DirectCast(Name, StringResourceId).Value), wLanguage, lpData, cbData)
            Else
                Return UpdateResource(hUpdate, (DirectCast(Type, StringResourceType).Value), (DirectCast(Name, StringResourceId).Value), wLanguage, lpData, cbData)
            End If
        End If
    End Function
#End Region

    Friend Enum RESOURCE_ID_Constants
        CREATEPROCESS_MANIFEST_RESOURCE_ID = 1
        ISOLATIONAWARE_MANIFEST_RESOURCE_ID = 2
        ISOLATIONAWARE_NOSTATICIMPORT_MANIFEST_RESOURCE_ID = 3
        MINIMUM_RESERVED_MANIFEST_RESOURCE_ID = 1   ' /*inclusive*/
        MAXIMUM_RESERVED_MANIFEST_RESOURCE_ID = 16  ' /*inclusive*/
    End Enum

    'Friend Declare Function GetSystemDefaultLangID Lib "kernel32.dll" () As Int16

    Friend Const LANG_NEUTRAL As UInt16 = &H0
    Friend Const SUBLANG_NEUTRAL As UInt16 = &H0

    Friend Declare Auto Function LoadLibrary Lib "kernel32.dll" ( _
         ByVal lpLibFileName As String _
    ) As IntPtr

    Friend Declare Auto Function LoadLibraryEx Lib "kernel32.dll" ( _
        ByVal lpFileName As String, _
        ByVal hFile As IntPtr, _
        ByVal dwFlags As LoadLibraryEx_Flags _
    ) As IntPtr

    <Flags()> _
    Friend Enum LoadLibraryEx_Flags
        DONT_RESOLVE_DLL_REFERENCES = &H1
        LOAD_IGNORE_CODE_AUTHZ_LEVEL = &H10
        LOAD_LIBRARY_AS_DATAFILE = &H2
        LOAD_WITH_ALTERED_SEARCH_PATH = &H8
    End Enum

    Friend Declare Function FreeLibrary Lib "kernel32.dll" ( _
        ByVal hLibModule As IntPtr _
    ) As Boolean

    ''' <summary>
    '''   Creates a language identifier based on the specified primary
    '''   language and sub language identifiers.
    ''' </summary>
    ''' <param name="usPrimaryLanguage">
    '''   Identifier of the primary language.
    ''' </param>
    ''' <param name="usSubLanguage">Identifier of the sub language.</param>
    ''' <returns>
    '''   A value representing a language identifier based on the specified
    '''   language and sub language identifiers.
    ''' </returns>
    Friend Shared Function MAKELANGID( _
        ByVal usPrimaryLanguage As UInt16, _
        ByVal usSubLanguage As UInt16 _
    ) As Int16
        Return CShort(usSubLanguage << 10 Or usPrimaryLanguage)
    End Function

    ''' <summary>
    '''   Returns whether or not the value specified in the
    '''   <paramref name="_r"/> parameter is an integer resource
    '''   identifier.
    ''' </summary>
    ''' <param name="_r">32-Bit-Ganzzahl, die geprft werden soll.</param>
    ''' <returns>
    '''   <c>True</c> if the value specified in the parameter
    '''   <paramref name="_r"/> is a valid integer resource identifier;
    '''   otherwise, <c>False</c>.
    ''' </returns>
    Friend Shared Function IS_INTRESOURCE(ByVal _r As IntPtr) As Boolean

        ' #define IS_INTRESOURCE(_r) (((ULONG_PTR)(_r) >> 16) == 0)
        Return _r.ToInt32() >> 16 = 0
    End Function

    Friend Shared Function MAKEINTRESOURCE(ByVal wInteger As Int16) As IntPtr
        Return New IntPtr(wInteger)
    End Function

    Friend Shared ReadOnly NeutralLanguage As Int16 = _
        NativeMethods.MAKELANGID( _
            NativeMethods.LANG_NEUTRAL, _
            NativeMethods.SUBLANG_NEUTRAL _
        )

    Friend Declare Auto Function VerLanguageName Lib "kernel32.dll" ( _
        ByVal wLang As Int32, _
        ByVal szLang As String, _
        ByVal nSize As Int32 _
    ) As Int32

    Friend Shared Function LangIdToString(ByVal wLang As Int16) As String
        Dim s As String = Space(128)
        Dim n As Int32 = VerLanguageName(wLang, s, s.Length)
        If n = 0 Then
            Throw New Exception(My.Resources.ExceptionUnspecifiedErrorOccured)
        Else
            Return Left(s, n)
        End If
    End Function

    Friend Declare Auto Function GetLocaleInfo Lib "kernel32.dll" ( _
        ByVal Locale As Int32, _
        ByVal LCType As Int32, _
        ByVal lpLCData As String, _
        ByVal cchData As Int32 _
    ) As Int32

    Friend Const LOCALE_SISO639LANGNAME As Int32 = &H59
    Friend Const LOCALE_SISO3166CTRYNAME As Int32 = &H5A

    ' TODO:  Replace with an implementation not returning the
    ' country/region code if no country is specified.
    Friend Shared Function LangIdToTwoLetterCode(ByVal wLang As Int16) As String
        If wLang = 0 Then
            Return "x-WW"
        End If
        Dim dwLocale As Int32 = MAKELCID(wLang, SORT_DEFAULT)
        Dim n As Integer

        ' Two-letter languge code + null character.
        Dim LangName As String = Space(3)
        n = _
            GetLocaleInfo( _
                dwLocale, _
                LOCALE_SISO639LANGNAME, _
                LangName, _
                LangName.Length _
            )
        If n = 0 Then
            Throw New Win32Exception()
        End If
        LangName = Left(LangName, n - 1)

        ' Two-letter country/region code + null character.
        Dim CtryName As String = Space(3)
        n = _
            GetLocaleInfo( _
                dwLocale, _
                LOCALE_SISO3166CTRYNAME, _
                CtryName, _
                CtryName.Length _
            )
        If n = 0 Then
            Throw New Win32Exception()
        End If
        CtryName = Left(CtryName, n - 1)

        Return LangName & "-" & CtryName
    End Function

    Friend Const SORT_DEFAULT As Int16 = &H0

    Friend Shared Function MAKELCID( _
        ByVal wLanguageID As Int16, _
        ByVal wSortID As Int16 _
    ) As Int32
        Return CInt(wSortID) << 16 Or CInt(wLanguageID)
    End Function

    Friend Declare Auto Function GetModuleFileName Lib "kernel32.dll" ( _
        ByVal hModule As IntPtr, _
        ByVal lpFilename As String, _
        ByVal nSize As Int32 _
    ) As Int32

    Friend Const MAX_PATH As Int32 = 260

    Friend Shared Function GetModuleFileName(ByVal hModule As IntPtr) As String
        Dim Buffer As String = Space(MAX_PATH)
        Dim n As Int32 = GetModuleFileName(hModule, Buffer, Buffer.Length)
        If n = 0 Then
            Throw New Win32Exception()
        Else
            Return Left(Buffer, n)
        End If
    End Function
End Class